stages:
  - test
  - build
  - upload
  - release

image: openjdk:8

variables:
  SERVER_NAME: ChatServidor
  CLIENT_NAME: ChatCliente
  PACKAGE_REGISTRY_URL: "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/ChatServerClient/$CI_COMMIT_TAG"

before_script:
  - apt-get update
  - apt-get install ant -y

server-tests:
  stage: test

  script:
  - cd $SERVER_NAME
  - ant test

client-tests:
  stage: test
  
  script:
  - cd $CLIENT_NAME
  - ant test

build-server:
  stage: build

  script:
  - cd $SERVER_NAME
  - ant clean
  - ant jar

  artifacts:
    name: $SERVER_NAME
    paths:
    - $SERVER_NAME/dist/*.jar

build-client:
  stage: build
  
  script:
  - cd $CLIENT_NAME
  - ant clean
  - ant jar

  artifacts:
    name: $CLIENT_NAME
    paths:
    - $CLIENT_NAME/dist/*.jar

upload-files:
  stage: upload
  image: curlimages/curl:latest

  rules:
  - if: $CI_COMMIT_TAG

  before_script: [] # From this job, there is no need to run the default before_script (ant install)

  script:
  - |
    curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file $SERVER_NAME/dist/$SERVER_NAME.jar "${PACKAGE_REGISTRY_URL}/$SERVER_NAME.jar"
    curl --header "JOB-TOKEN: ${CI_JOB_TOKEN}" --upload-file $CLIENT_NAME/dist/$CLIENT_NAME.jar "${PACKAGE_REGISTRY_URL}/$CLIENT_NAME.jar"

release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest

  rules:
  - if: $CI_COMMIT_TAG

  before_script: []
  
  script:
  - echo Running release

  release:
    name: 'Release $CI_COMMIT_TAG'
    description: 'Created using the release-cli $EXTRA_DESCRIPTION' 
    tag_name: '$CI_COMMIT_TAG'                                       
    ref: '$CI_COMMIT_TAG'
   
    assets:
      links:
        - name: '$SERVER_NAME.jar'
          url: '${PACKAGE_REGISTRY_URL}/$SERVER_NAME.jar'

        - name: '$CLIENT_NAME.jar'
          url: '${PACKAGE_REGISTRY_URL}/$CLIENT_NAME.jar'
